/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : I2Cʾ
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

#include "CH58x_common.h"
#include<math.h>
//****************************************
// MPU6050ڲַ
//****************************************
#define SMPLRT_DIV      0x19    //ǲʣֵ0x07(125Hz)
#define CONFIG          0x1A    //ͨ˲Ƶʣֵ0x06(5Hz)
#define GYRO_CONFIG     0x1B    //Լ켰Χֵ0x18(Լ죬2000deg/s)
#define ACCEL_CONFIG    0x1C    //ټԼ졢Χͨ˲Ƶʣֵ0x01(Լ죬2G5Hz)
#define ACCEL_XOUT_H    0x3B
#define ACCEL_XOUT_L    0x3C
#define ACCEL_YOUT_H    0x3D
#define ACCEL_YOUT_L    0x3E
#define ACCEL_ZOUT_H    0x3F
#define ACCEL_ZOUT_L    0x40
#define TEMP_OUT_H      0x41
#define TEMP_OUT_L      0x42
#define GYRO_XOUT_H     0x43
#define GYRO_XOUT_L     0x44
#define GYRO_YOUT_H     0x45
#define GYRO_YOUT_L     0x46
#define GYRO_ZOUT_H     0x47
#define GYRO_ZOUT_L     0x48
#define PWR_MGMT_1      0x6B    //Դֵ0x00()
#define WHO_AM_I        0x75    //IICַĴ(Ĭֵ0x68ֻ)
#define MPU6050Address    0xD0    //IICдʱĵַֽݣ+1Ϊȡ
/* I2C Mode Definition */
#define HOST_MODE     0
#define SLAVE_MODE    1

/* I2C Communication Mode Selection */
#define I2C_MODE      HOST_MODE
//#define I2C_MODE   SLAVE_MODE

/* Global define */
#define Size          7
#define RxAdderss     0x53
#define TxAdderss     0x52
int MPU6050TwoBytesRead(unsigned char regAddress);
void MPU6050Init();

/*--------------------------------------------------------------------------------*/
int main()
{
    int Xacceleration,Yacceleration,Zacceleration;

    SetSysClock(CLK_SOURCE_PLL_60MHz);
    DelayMs(10);
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA);

    DelayMs(500);

    UART1_DefInit();
    PRINT("MPU6050 Test\r\n");
    PRINT("MPU6050Init...\r\n");
    MPU6050Init();
    PRINT("MPU6050Init done\r\n");
    DelayMs(150);
    while(1)
    {
        //ȡXٶ
        Xacceleration = MPU6050TwoBytesRead(ACCEL_XOUT_H);
        PRINT("Xacceleration %d \r\n",Xacceleration);
        //ȡYٶ
        Yacceleration = MPU6050TwoBytesRead(ACCEL_YOUT_H);
        PRINT("Yacceleration %d \r\n",Yacceleration);
        //ȡZٶ
        Zacceleration = MPU6050TwoBytesRead(ACCEL_ZOUT_H);
        PRINT("Zacceleration %d \r\n",Zacceleration);
        PRINT("------------------------------------\r\n");
        DelayMs(1000);
    }
}
/* MPU6050д뵥ֽ */
void MPU6050SingleWrite(unsigned char regAddress,unsigned char regData)
{
    while(I2C_GetFlagStatus(I2C_FLAG_BUSY) != RESET);//ȴ߿ BUSY=0
    I2C_GenerateSTART(ENABLE);//ʼź
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_MODE_SELECT));//ȴߴæ״̬ BUSY=1 MSL=1 SB=1
    I2C_Send7bitAddress(MPU6050Address, I2C_Direction_Transmitter);//дַ
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED));//ȴߴæ״̬ BUSY=1 MSL=1 ADDR=1 TxE=1
    //ȴݼĴΪ(TxE=1) ͼĴַ
    if(I2C_GetFlagStatus(I2C_FLAG_TXE) != RESET) I2C_SendData(regAddress);
    //ȴݼĴΪ(TxE=1) 
    if(I2C_GetFlagStatus(I2C_FLAG_TXE) != RESET) I2C_SendData(regData);
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_BYTE_TRANSMITTED));//ȴߴæ״̬ BUSY=1 MSL=1 TRA=1 TxE=1 BTF=1
    I2C_GenerateSTOP(ENABLE);//ֹͣź
}
/* MPU6050ȡֽ */
unsigned char MPU6050SingleRead(unsigned char regAddress)
{
    unsigned char regData;

    while(I2C_GetFlagStatus(I2C_FLAG_BUSY) != RESET);//ȴ߿ BUSY=0
    I2C_GenerateSTART(ENABLE);//ʼź
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_MODE_SELECT));//ȴߴæ״̬ BUSY=1 MSL=1 SB=1
    I2C_Send7bitAddress(MPU6050Address, I2C_Direction_Transmitter);//дַ
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));//ȴߴæ״̬ BUSY=1 MSL=1 ADDR=1 TxE=1
    //ȴݼĴΪ(TxE=1) ͼĴַ
    if(I2C_GetFlagStatus(I2C_FLAG_TXE) != RESET) I2C_SendData(regAddress);

    //while(I2C_GetFlagStatus(I2C_FLAG_BUSY) != RESET);//ȴ߿ BUSY=0
    I2C_GenerateSTART(ENABLE);//ʼź
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_MODE_SELECT));//ȴߴæ״̬ BUSY=1 MSL=1 SB=1
    I2C_Send7bitAddress(MPU6050Address, I2C_Direction_Receiver);//Ͷַ
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));
    //while(!I2C_GetFlagStatus(I2C_FLAG_RXNE))//ȴݼĴǿ(RxEN=1)
        regData = I2C_ReceiveData();
    I2C_AcknowledgeConfig(DISABLE);//NAKź
    I2C_GenerateSTOP(ENABLE);//ֹͣź

    return regData;
}
/* MPU6050ȡֽ */
void MPU6050MultibyteRead(unsigned char regAddress,unsigned char *receiveData,unsigned char len)
{
    while(I2C_GetFlagStatus(I2C_FLAG_BUSY) != RESET);//ȴ߿ BUSY=0
    I2C_GenerateSTART(ENABLE);//ʼź
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_MODE_SELECT));//ȴߴæ״̬ BUSY=1 MSL=1 SB=1
    I2C_Send7bitAddress(MPU6050Address, I2C_Direction_Transmitter);//дַ
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));//ȴߴæ״̬ BUSY=1 MSL=1 ADDR=1 TxE=1
    //ȴݼĴΪ(TxE=1) ͼĴַ
    if(I2C_GetFlagStatus(I2C_FLAG_TXE) != RESET) I2C_SendData(regAddress);
    while(I2C_GetFlagStatus(I2C_FLAG_BUSY) != RESET);//ȴ߿ BUSY=0
    I2C_GenerateSTART(ENABLE);//ʼź
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_MODE_SELECT));//ȴߴæ״̬ BUSY=1 MSL=1 SB=1
    I2C_Send7bitAddress(MPU6050Address, I2C_Direction_Receiver);//Ͷַ
    while(len > 1)
    {
        while(!I2C_GetFlagStatus(I2C_FLAG_RXNE))//ȴݼĴǿ(RxEN=1)
        *receiveData++ = I2C_ReceiveData();
        I2C_AcknowledgeConfig(ENABLE);//ACKź
        len--;
    }
    while(!I2C_GetFlagStatus(I2C_FLAG_RXNE))//ȴݼĴǿ(RxEN=1)
    *receiveData = I2C_ReceiveData();
    I2C_AcknowledgeConfig(DISABLE);//NAKź
    I2C_GenerateSTOP(ENABLE);//ֹͣź
}
/* MPU6050ȡֽ */
int MPU6050TwoBytesRead(unsigned char regAddress)
{
    char regHData,regLData;
/*
    while(I2C_GetFlagStatus(I2C_FLAG_BUSY) != RESET);//ȴ߿ BUSY=0
    I2C_GenerateSTART(ENABLE);//ʼź
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_MODE_SELECT));//ȴߴæ״̬ BUSY=1 MSL=1 SB=1
    I2C_Send7bitAddress(MPU6050Address, I2C_Direction_Transmitter);//дַ
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));//ȴߴæ״̬ BUSY=1 MSL=1 ADDR=1 TxE=1
    //ȴݼĴΪ(TxE=1) ͼĴַ
    if(I2C_GetFlagStatus(I2C_FLAG_TXE) != RESET) I2C_SendData(regAddress);

    I2C_GenerateSTART(ENABLE);//ʼź
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_MODE_SELECT));//ȴߴæ״̬ BUSY=1 MSL=1 SB=1
    I2C_Send7bitAddress(MPU6050Address, I2C_Direction_Receiver);//Ͷַ

    while(!I2C_CheckEvent(I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));
    //while(!I2C_GetFlagStatus(I2C_FLAG_RXNE))//ȴݼĴǿ(RxEN=1)
        regHData = I2C_ReceiveData();//ոֽ
    I2C_AcknowledgeConfig(ENABLE);//ACKź
    while(!I2C_CheckEvent(I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED));
    //while(!I2C_GetFlagStatus(I2C_FLAG_RXNE))//ȴݼĴǿ(RxEN=1)
        regLData = I2C_ReceiveData();//յֽ
    I2C_AcknowledgeConfig(DISABLE);//NAKź
    I2C_GenerateSTOP(ENABLE);//ֹͣź
*/
    regHData = MPU6050SingleRead(regAddress);
    regLData = MPU6050SingleRead(regAddress + 1);
    return (regHData << 8) + regLData;
}
/* MPU6050ʼ */
void MPU6050Init()
{
    GPIOB_ModeCfg(GPIO_Pin_13 | GPIO_Pin_12, GPIO_ModeIN_PU);//ʼIICţͨ R16_PIN_ALTERNATEӳ䵽PB21 PB20
    I2C_Init(I2C_Mode_I2C, 400000, I2C_DutyCycle_16_9, I2C_Ack_Enable, I2C_AckAddr_7bit, TxAdderss);//IICʼ
    MPU6050SingleWrite(PWR_MGMT_1, 0x00);//״̬
    MPU6050SingleWrite(SMPLRT_DIV, 0x07);
    MPU6050SingleWrite(CONFIG, 0x06);
    MPU6050SingleWrite(GYRO_CONFIG, 0x18);
    MPU6050SingleWrite(ACCEL_CONFIG, 0x01);
}

